# Free Monad sample project

Using [Hydra](https://github.com/graninas/Hydra) as a reference for study.

# Library

https://hackage.haskell.org/package/free

# Resources

- [What are free monads](https://stackoverflow.com/questions/13352205/what-are-free-monads)
- [You could have invented free monads](http://www.haskellforall.com/2012/06/you-could-have-invented-free-monads.html)
- [Purify code using free monads](http://www.haskellforall.com/2012/07/purify-code-using-free-monads.html)
- [What does free buy us](https://www.parsonsmatt.org/2017/09/22/what_does_free_buy_us.html)
- [Random gist](https://gist.github.com/CMCDragonkai/165d9a598b8fb333ea65)
- [Free Monads](https://www.tweag.io/blog/2018-02-05-free-monads/)
- [Many roads to free monads](https://www.schoolofhaskell.com/user/dolio/many-roads-to-free-monads)
- [Hierarchical Free Monads & Software Design in Functional Programming by Alexander Granin](https://www.youtube.com/watch?v=3GKQ4ni2pS0)

# Free Monads Performance

- [Asymptotic Improvement of Computations over Free Monads](https://citeseerx.ist.psu.edu/viewdoc/download?doi=10.1.1.143.2323&rep=rep1&type=pdf)
- [Free Monads for less - Part 1](http://comonad.com/reader/2011/free-monads-for-less/)
- [Free Monads for less - Part 2](http://comonad.com/reader/2011/free-monads-for-less-2/)
- [Free Monads for less - Part 3](http://comonad.com/reader/2011/free-monads-for-less-3/)
- [Kan Extensions](http://comonad.com/reader/2008/kan-extensions/)
- [The Free and The Furious: And by 'Furious' I mean Codensity](https://www.youtube.com/watch?v=EiIZlX_k89Y)
- [Effects for less - Great talk, must watch](https://www.youtube.com/watch?v=0jI-AlWEwYI)

# Fix Point

- [Fix and Recursion](https://en.wikibooks.org/wiki/Haskell/Fix_and_recursion)
- [The Y Combinator](https://mvanier.livejournal.com/2700.html)
- [The Y Combinator - Slight Return](https://mvanier.livejournal.com/2897.html)
- [A series of articles on Recursion schemes](https://blog.sumtypeofway.com/archive.html)
- [Understanding Algebras](https://www.schoolofhaskell.com/user/bartosz/understanding-algebras)

# Jupyter Notebooks (Includes the one used for Free Monad)
- [https://gitlab.com/SanchayanMaity/haskell-notebooks](https://gitlab.com/SanchayanMaity/haskell-notebooks)

# youtube Recording of the talk

https://www.youtube.com/watch?v=fhu1UQel5eo
